

#include	"main.h"


/**************************************************************
*
*	Definitii macro
*
**************************************************************/

#define		MAX_CALL_DEPTH 10

/**************************************************************
*
*	Declaratii variabile
*
**************************************************************/
static		long		BufferIndex;
static		void*		pBuffersList[MAX_CALL_DEPTH];



/**************************************************************
*
*	Definitii functii
*
**************************************************************/

// Initializeaza modulul
void
	InitBuffers ( void )
	{
	BufferIndex=0;
	}
// Finalizeaza modulul
void
	DoneBuffers ( void )
	{
	while(BufferIndex>0)
		FreeBuffer(pBuffersList[--BufferIndex]);
	}



#ifdef	DB_PROGRAM
// cauta in baza de date programul "strNumeProg" si declanseaza scanarea
// intoarce pointer catre buffer
void*
	AllocBuffer	(
				char*	 strNumeProg
				)
	{
	int			len;
	void*		pmem;


    CString         strSQL;
    strSQL.Format
        (
        "SELECT * \
        FROM __tb_Program \
        WHERE Program_Name='%s'",
        (char*)strNumeProg
        );

	IOKpslRecordsetPtr			iR;
    BSTR                        bstrMsg;
    long                        lErrMsg;
    iDA->get_Select(strSQL.AllocSysString(),&lErrMsg,&bstrMsg,(IDispatch**)&iR);
    if (lErrMsg!=0) throw CString(bstrMsg);
    if (iR->Count<1)
		{
		OutputMsg("Programul \"%s\" nu exista in baza de date\n",strNumeProg);
		throw new ExceptionProgramNotFound;
		}

	_variant_t		vtTemp;
	vtTemp = iR->Fields->Item["Program_Text"]->GetValue();

	_bstr_t			bstrTextProg;
	bstrTextProg = (_bstr_t)vtTemp;

	len = bstrTextProg.length();
	if(!(pmem = malloc(len+2)))		throw CString("Memorie insuficienta");
	memset(pmem,0,len+2);
	memcpy(pmem, (char*)bstrTextProg,len);

	// Aici e o prblema :"yy_scan_string" apeleaza si "yy_switch_to_buffer"
	// ceea ce in cazul depasirii pBufferList devine o problema
	// trebuie sa apelez "yy_scan_strings" si "yy_switch_to_buffers" in acelasi timp

	//if (!(pbuff=lex_set_buffer(pmem)))		throw CString("Memorie insuficienta");
	//free(pmem);
	//return pbuff;

	return pmem;
	}
#endif

#ifdef	FILE_PROGRAM
// cauta in baza de date programul "strNumeProg" si declanseaza scanarea
// intoarce pointer catre buffer
void*
	AllocBuffer	(
				char*	 strNumeProg
				)
	{
	FILE*		file;
	int			len;
	char*		pmem;

	file=fopen(strNumeProg,"r");
	if(!file)		throw CString("Fisierul nu exista");
	len = _filelength(_fileno(file));
	if(!(pmem = (char*)malloc(len+2)))			throw CString("Memorie insuficienta");
	memset(pmem,0,len+2);
	fread((void*)pmem,1,len,file);
	fclose(file);

	return pmem;
	}
#endif




// Elibereaza memoria alocata pentru buffer
void
	FreeBuffer	(
				void*	 pProgramBuffer
				)
	{
	lex_free_buffer(pProgramBuffer);
	}


// Comuta buffer-ul pentru lex
void
	PushBuffer	(
				void*	 pSourceBuffer
				)
	{
	if(BufferIndex>=MAX_CALL_DEPTH)
		{
		OutputMsg("Nivelul maxim(%d) de apeluri de programe a fost depasit\n",MAX_CALL_DEPTH);
		throw new ExceptionCallMaxDeepExceed;
		}

	void*		pBuff;

	if (!(pBuff=lex_set_buffer(pSourceBuffer)))
		{
		OutputMsg("Memorie insuficienta");
		throw new CString("Exceptie : memorie insuficienta");
		}
	else
		pBuffersList[BufferIndex++] = pBuff;
	// lex_set_buffer face si switch buffer
	// lex_switch_buffer(pProgramBuffer);
	}

// Comuta buffer-ul pentru lex
void*
	PopBuffer	( void )
	{
	void*		pTemp=NULL;
	if (BufferIndex>0)
		{
		pTemp = pBuffersList[--BufferIndex];
		if (BufferIndex>0)
			lex_switch_buffer(pBuffersList[BufferIndex-1]);
		}
	return pTemp;
	}

